package com.biganto.visual.roompark.domain.interactor

import com.biganto.visual.roompark.domain.model.AlbumSortedModel
import com.biganto.visual.roompark.domain.use_case.AlbumsUseCase
import io.reactivex.Observable
import javax.inject.Inject

/**
 * Created by Vladislav Bogdashkin on 09.10.2019.
 */

class AlbumssInteractor @Inject constructor(
    private val useCase: AlbumsUseCase
) {

    fun fetchHeaderAlbums() = useCase.getProgressAlbums()

    fun fetchAlbumPhotos(parentId:Int): Observable<MutableList<AlbumSortedModel>> =
        useCase.getChildAlbum(parentId)
            .flatMapIterable{ it }
            .flatMap {album -> useCase.getPhotos(album.albumId).map {
                AlbumSortedModel(album.title,album.published,album.albumId,it)
           } }
            .toList()
            .toObservable()
}



